HDU 1669 Monkey and Banana

来源:互联网 发布:建筑模型动画软件 编辑:程序博客网 时间:2024/06/03 18:03

传送门

Monkey and Banana

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 12003 Accepted Submission(s): 6275

Problem Description
A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height.

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn’t be stacked.

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.

Input
The input file will contain one or more test cases. The first line of each test case contains an integer n,
representing the number of different blocks in the following data set. The maximum value for n is 30.
Each of the next n lines contains three integers representing the values xi, yi and zi.
Input is terminated by a value of zero (0) for n.

Output
For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format “Case case: maximum height = height”.

Sample Input
1
10 20 30
2
6 8 10
5 5 5
7
1 1 1
2 2 2
3 3 3
4 4 4
5 5 5
6 6 6
7 7 7
5
31 41 59
26 53 58
97 93 23
84 62 64
33 83 27
0

Sample Output
Case 1: maximum height = 40
Case 2: maximum height = 21
Case 3: maximum height = 28
Case 4: maximum height = 342

Source
University of Ulm Local Contest 1996
题目大意:
就是给定 n 种不同的长宽高为(x,y,z)的木板,然后让你一层一层往上摆,注意的是这些木板是很多很多的,当作是无穷,往上摆的时候满足的条件是上面一层的模板的长宽一定比下面一层的长宽大,而且是长比长大,宽比宽大(长和宽不是固定的也就是说长可以当作宽,高也可以当作宽,宽可以当作长),让你求得是在满足条件的情况下,高度最大。
解题思路:
听人说这是一个DP的问题,可是貌似也不用非得DP吧,我们可以把每次可以选的长和宽记录下来,但是这个情况有点多,所以我们可以通过面积来判断,因为如果要想满足条件的话,上面的面积一定是比下面的面积大的,所以我们就可以求一下面积,并按照面积从小到大排序,然后我们每次比较就行了,只需要比较长和宽,长和宽比,长和长比,如果大的话,就加上高度,具体操作看代码:

上代码:

#include <iostream>#include <cstdio>#include <cstring>#include <cstdlib>#include <algorithm>using namespace std;const int INF = 1e9+5;struct node{    int x, y, z, area;} a[200];bool cmp(node a, node b){    return a.area < b.area;}int dp[200];int main(){    int cas = 1;    int n, _x, _y, _z;    while(cin>>n, n)    {        int len = 0;        for(int i=0; i<n; i++)        {            cin>>_x>>_y>>_z;            a[len].x = _x;            a[len].y = _y;            a[len].z = _z;            a[len].area = _x*_y;            len++;            a[len].x = _x;            a[len].y = _z;            a[len].z = _y;            a[len].area = _x*_z;            len++;            a[len].x = _z;            a[len].y = _y;            a[len].z = _x;            a[len].area = _y*_z;            len++;        }        sort(a, a+len, cmp);        for(int i=0; i<len; i++)            dp[i] = a[i].z;        for(int i=1; i<len; i++)        {            int Max = -INF;            for(int j=0; j<i; j++)            {                if(((a[i].x>a[j].x&&a[i].y>a[j].y) || (a[i].x>a[j].y&&a[i].y>a[j].x))                   && dp[j]>Max)                    Max = dp[j];            }            if(Max != -INF)                dp[i] += Max;        }        sort(dp, dp+len);        printf("Case %d: maximum height = %d\n",cas++,dp[len-1]);    }    return 0;}
0 0